<template>
  <el-container>
    <el-main>
      <p class="userTitle">User List</p>
      <el-table :data="users.filter(data => !search || data.userName.toLowerCase().includes(search.toLowerCase()))"
        height="750px" highlight-current-row style="width: 100%"
        :default-sort="{prop:'userName', order: 'descending'}">
        <el-table-column prop="userName" sortable label="user name"/>
        <el-table-column prop="email" sortable label="user email"/>
        <el-table-column prop="status" sortable label="status">
          <template slot-scope="scope">
            <p v-if="scope.row.status==true">Active</p>
            <p v-else>UnActive</p>
          </template>
        </el-table-column>
        <el-table-column align="right">
          <template slot="header" slot-scope="scope">
            <el-input v-model="search" size="mini" placeholder="Enter Key Word"/>
          </template>
          <template slot-scope="scope">
            <el-button
              size="mini"
              @click="handleEdit(scope.$index, scope.row)">Edit</el-button>
            <el-button v-if="isAdmin === true"
              size="mini"
              type="danger"
              @click="handleDelete(scope.$index, scope.row)">Delete</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page= "currentPage"
        :page-size= "pageSize"
        layout="total, prev, pager, next, jumper"
        :total= "totalCount">
      </el-pagination>
    </el-main>
  </el-container>
</template>

<script>
import {getUserList, deleteUser} from '@/apis/user'
export default {
  name: '#userList',
  inject: ['reload'],
  data () {
    return {
      users: [],
      search: '',
      currentPage: 1,
      pageSize: 10,
      totalCount: 0,
      isAdmin: this.$route.params.isAdmin
    }
  },
  created () {
    console.log(this.isAdmin)
    this.getUList()
  },
  methods: {
    handleEdit (index, row) {
      var userId = row.id
      console.log(userId)
      this.$router.push({
        path: '/home/userDetail',
        query: {
          userId: userId
        }
      })
    },
    handleDelete (index, row) {
      var userId = row.id
      this.$confirm('Are you sure to delete this user: ' + row.email, 'confirm', {
        cancelButtonText: 'cancel',
        confirmButtonText: 'yes',
        type: 'warning'
      }).then(() => {
        console.log('delete User ' + userId)
        this.deleteU(userId)
      }).catch(() => {
        // Just Cancel. No need to do anything.
      })
    },
    handleSizeChange (val) {
      this.pageSize = val
      console.log(this.pageSize)
    },
    handleCurrentChange (val) {
      this.currentPage = val
      this.getUList()
      this.search = ''
      console.log(this.currentPage)
    },
    getUList () {
      var start = (this.currentPage - 1) * this.pageSize + 1
      var pageSize = this.pageSize
      getUserList(start, pageSize).then(res => {
        console.log('Get User List')
        console.log(res)
        this.users = res.data.list
        this.totalCount = res.data.totalCount
      })
    },
    deleteU (userId) {
      deleteUser(userId).then(res => {
        console.log(res)

        if (res.data.actionState === 'SUCCESS') {
          this.$alert('User Delete Successfully', 'Success Message', {
            confirmButtonText: 'OK',
            callback: action => {
              console.log('reset')
              this.currentPage = 1
              this.reload()
            }
          })
        } else if (res.data.actionState === 'ERROR') {
          this.$alert(res.data.responseMessages[0], 'Error Message', {
            confirmButtonText: 'OK'
          })
        }
      })
    }
  }
}
</script>

<style>
  .userTitle {
    margin-top: 0px;
    color: rgb(197, 34, 34);
    font-size: 20px;
  }
</style>
